package cokr.xit.fims.crdn.dao;

import java.util.List;

import org.egovframe.rte.psl.dataaccess.mapper.Mapper;

import cokr.xit.fims.crdn.CrdnQuery;
import cokr.xit.foundation.component.AbstractMapper;

@Mapper("globalStngMapper")
public interface GlobalStngMapper extends AbstractMapper {

	/**기본금액을 조회한다.<br />
	 * {@link cokr.xit.fims.crdn.service.bean.CrdnStngBean#getBasicAmt(CrdnQuery)} 참고
	 * @param query 단속자료 정보
	 * @return 기본금액
	 */
	String selectBasicAmt(CrdnQuery query);

	/**기관코드에 따른 시군구코드를 조회한다.<br />
	 * @param institute 기관코드
	 * @return 시군구코드
	 */
	String selectSggCd(String institute);

	default String selectSggCdForCurrentUser() {
		return selectSggCd(currentUser().getInstitute());
	};

	/**시군구코드에 따른 법정동명 목록을 조회한다.<br />
	 * @param sggCd 시군구코드
	 * @return 법정동 목록
	 */
	List<String> selectStdgNmList(String sggCd);

	default List<String> selectStdgNmListForCurrentUser() {
		String sggCd = selectSggCd(currentUser().getInstitute());
		return selectStdgNmList(sggCd);
	};
}